import c4d
from c4d import gui
#Welcome to the world of Python


def main():
    
    cam = doc.GetActiveObjectsFilter(False,c4d.Ocamera,c4d.NOTOK)
    
    if cam:
        oldRd = doc.GetActiveRenderData() #c4d.RenderData
        
        oldRes = oldRd[c4d.RDATA_XRES]
        oldSens = cam[0][c4d.CAMERAOBJECT_APERTURE]
        
        newRes = gui.InputDialog("Nuova LARGHEZZA render")
        if not newRes:
            return
        
        newY = gui.InputDialog("Nuova ALTEZZA render")
        if not newY:
            return


        newRes = float(newRes)
        newY = float(newY)

        newSens = oldSens * (newRes/oldRes)
        
        doc.StartUndo()
        
        #doc.AddUndo(c4d.UNDOTYPE_CHANGE,cam[0])
        #cam[0][c4d.CAMERAOBJECT_APERTURE] = newSens
        
        newCam = cam[0].GetClone()
        newCam[c4d.CAMERAOBJECT_APERTURE] = newSens
        newCam.SetName(newCam.GetName()+"."+str(int(newRes))+" x "+str(int(newY)))
        doc.InsertObject(newCam)
        doc.AddUndo(c4d.UNDOTYPE_NEW,newCam)
        bd = doc.GetRenderBaseDraw()
        bd.SetSceneCamera(newCam)
        doc.SetActiveObject(newCam)
        
        newRd = oldRd.GetClone()
        newRd.SetName(str(int(newRes))+" x "+str(int(newY)))
        newRd[c4d.RDATA_XRES] = newRes
        newRd[c4d.RDATA_YRES] = newY
        newRd[c4d.RDATA_FILMASPECT] = (newRes/newY)
        
        doc.InsertRenderData(newRd)
        doc.AddUndo(c4d.UNDOTYPE_NEW,newRd)
        
        doc.SetActiveRenderData(newRd)

        doc.EndUndo()
    
    
    else:
        gui.MessageDialog('Seleziona una camera prima!')
    

    c4d.EventAdd()
    

if __name__=='__main__':
    main()
